import {
  OutpostsApi
} from "./chunk-WBGZSVLZ.js";
import {
  AKChart
} from "./chunk-VNZ4FZJR.js";
import "./chunk-KHGDVF4C.js";
import "./chunk-FVX4U7YJ.js";
import "./chunk-NMYJYET6.js";
import "./chunk-RLZHTYA5.js";
import "./chunk-GRDBDT5R.js";
import "./chunk-PBQRLLOY.js";
import "./chunk-VQFMAUVB.js";
import "./chunk-DN2ZD52M.js";
import "./chunk-J3PH67VS.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-CVYJ7ZJF.js";
import "./chunk-ONTZF75C.js";
import "./chunk-DNEL2E46.js";
import "./chunk-EOEQO3CH.js";
import "./chunk-XA5T5LFM.js";
import "./chunk-FKNZK3OF.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-EAIIBUQ3.js";
import "./chunk-BFQ5Q4FG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-KZQQG4Z5.js";
import "./chunk-M56I43HT.js";
import "./chunk-PEOJM4G4.js";
import "./chunk-CG2PRGI3.js";
import "./chunk-UZJTCI4U.js";
import "./chunk-NSQ22IJJ.js";
import "./chunk-AVL74GZG.js";
import "./chunk-UPA2WVNB.js";
import "./chunk-SQ5SVIIR.js";
import "./chunk-2XSPVNET.js";
import "./chunk-JXGF4NCN.js";
import "./chunk-HV5HJC7G.js";
import "./chunk-4TARICXF.js";
import "./chunk-ZIINSVS4.js";
import "./chunk-2SPTQERF.js";
import "./chunk-KSHJXCLS.js";
import "./chunk-2DGC2NAK.js";
import {
  Form
} from "./chunk-H6GN2355.js";
import "./chunk-GA6N3LLL.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-CZCZP242.js";
import "./chunk-IH3CVDIB.js";
import "./chunk-GW7NH4E2.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-3NWSPFFH.js";
import {
  list_default
} from "./chunk-TZQOYPLJ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-ENS5JEO5.js";
import "./chunk-SV4NNFYX.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-7CPINVRB.js";
import "./chunk-6OUYIMM6.js";
import {
  AKElement,
  CoreApi,
  DEFAULT_CONFIG,
  button_default,
  content_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-D7IHD7PN.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/applications/ApplicationAuthorizeChart.ts
var ApplicationAuthorizeChart = class extends AKChart {
  async apiRequest() {
    return new CoreApi(DEFAULT_CONFIG).coreApplicationsMetricsList({
      slug: this.applicationSlug
    });
  }
  timeTickCallback(tickValue, index, ticks) {
    const valueStamp = ticks[index];
    const delta = Date.now() - valueStamp.value;
    const ago = Math.round(delta / 1e3 / 3600 / 24);
    return msg(str`${ago} days ago`);
  }
  getChartData(data) {
    return {
      datasets: [
        {
          label: msg("Authorizations"),
          backgroundColor: "rgba(189, 229, 184, .5)",
          spanGaps: true,
          data: data.map((cord) => {
            return {
              x: cord.xCord || 0,
              y: cord.yCord || 0
            };
          }) || []
        }
      ]
    };
  }
};
__decorateClass([
  n()
], ApplicationAuthorizeChart.prototype, "applicationSlug", 2);
ApplicationAuthorizeChart = __decorateClass([
  t("ak-charts-application-authorize")
], ApplicationAuthorizeChart);

// src/admin/applications/ApplicationCheckAccessForm.ts
var ApplicationCheckAccessForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully sent test-request.");
  }
  async send(data) {
    this.request = data.forUser;
    const result = await new CoreApi(DEFAULT_CONFIG).coreApplicationsCheckAccessRetrieve({
      slug: this.application?.slug,
      forUser: data.forUser
    });
    return this.result = result;
  }
  resetForm() {
    super.resetForm();
    this.result = void 0;
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  renderResult() {
    return x`
            <ak-form-element-horizontal label=${msg("Passing")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <span class="pf-c-form__label-text">
                            <ak-status-label ?good=${this.result?.passing}></ak-status-label>
                        </span>
                    </div>
                </div>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <ul>
                            ${(this.result?.messages || []).length > 0 ? this.result?.messages?.map((m) => {
      return x`<li>
                                          <span class="pf-c-form__label-text">${m}</span>
                                      </li>`;
    }) : x`<li>
                                      <span class="pf-c-form__label-text">-</span>
                                  </li>`}
                        </ul>
                    </div>
                </div>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Log messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <dl class="pf-c-description-list pf-m-horizontal">
                            <ak-log-viewer .logs=${this.result?.logMessages}></ak-log-viewer>
                        </dl>
                    </div>
                </div>
            </ak-form-element-horizontal>
        `;
  }
  renderForm() {
    return x`<ak-form-element-horizontal
                label=${msg("User")}
                ?required=${true}
                name="forUser"
            >
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return x`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.pk;
    }}
                    .selected=${(user) => {
      return user.pk.toString() === this.request?.toString();
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            ${this.result ? this.renderResult() : x``}`;
  }
};
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "application", 2);
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "result", 2);
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "request", 2);
ApplicationCheckAccessForm = __decorateClass([
  t("ak-application-check-access-form")
], ApplicationCheckAccessForm);

// src/admin/applications/ApplicationViewPage.ts
var ApplicationViewPage = class extends AKElement {
  constructor() {
    super(...arguments);
    this.missingOutpost = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      list_default,
      banner_default,
      page_default,
      content_default,
      button_default,
      description_list_default,
      grid_default,
      card_default
    ];
  }
  fetchIsMissingOutpost(providersByPk) {
    new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesList({
      providersByPk,
      pageSize: 1
    }).then((outposts) => {
      if (outposts.pagination.count < 1) {
        this.missingOutpost = true;
      }
    });
  }
  fetchApplication(slug) {
    new CoreApi(DEFAULT_CONFIG).coreApplicationsRetrieve({ slug }).then((app) => {
      this.application = app;
      if (app.providerObj && [
        RbacPermissionsAssignedByUsersListModelEnum.ProvidersProxyProxyprovider.toString(),
        RbacPermissionsAssignedByUsersListModelEnum.ProvidersLdapLdapprovider.toString()
      ].includes(app.providerObj.metaModelName)) {
        this.fetchIsMissingOutpost([app.provider || 0]);
      }
    });
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("applicationSlug") && this.applicationSlug) {
      this.fetchApplication(this.applicationSlug);
    }
  }
  render() {
    return x`<ak-page-header
                header=${this.application?.name || msg("Loading")}
                description=${o(this.application?.metaPublisher)}
                .iconImage=${true}
            >
                <ak-app-icon
                    size=${"pf-m-md" /* Medium */}
                    slot="icon"
                    .app=${this.application}
                ></ak-app-icon>
            </ak-page-header>
            ${this.renderApp()}`;
  }
  renderApp() {
    if (!this.application) {
      return x`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    return x`<ak-tabs>
            ${this.missingOutpost ? x`<div slot="header" class="pf-c-banner pf-m-warning">
                      ${msg("Warning: Application is not used by any Outpost.")}
                  </div>` : x``}
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-2-col-on-xl pf-m-2-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Related")}</div>
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list">
                                ${this.application.providerObj ? x`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Provider")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <a
                                                      href="#/core/providers/${this.application.providerObj?.pk}"
                                                  >
                                                      ${this.application.providerObj?.name}
                                                      (${this.application.providerObj?.verboseName})
                                                  </a>
                                              </div>
                                          </dd>
                                      </div>` : x``}
                                ${(this.application.backchannelProvidersObj || []).length > 0 ? x`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Backchannel Providers")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <ul class="pf-c-list">
                                                      ${this.application.backchannelProvidersObj.map(
      (provider) => {
        return x`
                                                                  <li>
                                                                      <a
                                                                          href="#/core/providers/${provider.pk}"
                                                                      >
                                                                          ${provider.name}
                                                                          (${provider.verboseName})
                                                                      </a>
                                                                  </li>
                                                              `;
      }
    )}
                                                  </ul>
                                              </div>
                                          </dd>
                                      </div>` : x``}
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Policy engine mode")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.application.policyEngineMode?.toUpperCase()}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Edit")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ak-forms-modal>
                                                <span slot="submit"> ${msg("Update")} </span>
                                                <span slot="header">
                                                    ${msg("Update Application")}
                                                </span>
                                                <ak-application-form
                                                    slot="form"
                                                    .instancePk=${this.application.slug}
                                                >
                                                </ak-application-form>
                                                <button
                                                    slot="trigger"
                                                    class="pf-c-button pf-m-secondary"
                                                >
                                                    ${msg("Edit")}
                                                </button>
                                            </ak-forms-modal>
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Check access")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ak-forms-modal .closeAfterSuccessfulSubmit=${false}>
                                                <span slot="submit"> ${msg("Check")} </span>
                                                <span slot="header">
                                                    ${msg("Check Application access")}
                                                </span>
                                                <ak-application-check-access-form
                                                    slot="form"
                                                    .application=${this.application}
                                                >
                                                </ak-application-check-access-form>
                                                <button
                                                    slot="trigger"
                                                    class="pf-c-button pf-m-secondary"
                                                >
                                                    ${msg("Test")}
                                                </button>
                                            </ak-forms-modal>
                                        </div>
                                    </dd>
                                </div>
                                ${this.application.launchUrl ? x`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Launch")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <a
                                                      target="_blank"
                                                      href=${this.application.launchUrl}
                                                      slot="trigger"
                                                      class="pf-c-button pf-m-secondary"
                                                  >
                                                      ${msg("Launch")}
                                                  </a>
                                              </div>
                                          </dd>
                                      </div>` : x``}
                            </dl>
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-10-col-on-xl pf-m-10-col-on-2xl"
                    >
                        <div class="pf-c-card__title">
                            ${msg("Logins over the last week (per 8 hours)")}
                        </div>
                        <div class="pf-c-card__body">
                            ${this.application && x` <ak-charts-application-authorize
                                applicationSlug=${this.application.slug}
                            >
                            </ak-charts-application-authorize>`}
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Changelog")}</div>
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.application.pk || ""}
                                targetModelApp="authentik_core"
                                targetModelName="application"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-policy-bindings"
                data-tab-title="${msg("Policy / Group / User Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-c-card">
                    <div class="pf-c-card__title">
                        ${msg("These policies control which users can access this application.")}
                    </div>
                    <ak-bound-policies-list .target=${this.application.pk}>
                    </ak-bound-policies-list>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.CoreApplication}
                objectPk=${this.application.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], ApplicationViewPage.prototype, "applicationSlug", 2);
__decorateClass([
  r()
], ApplicationViewPage.prototype, "application", 2);
__decorateClass([
  r()
], ApplicationViewPage.prototype, "missingOutpost", 2);
ApplicationViewPage = __decorateClass([
  t("ak-application-view")
], ApplicationViewPage);
export {
  ApplicationViewPage
};
//# sourceMappingURL=ApplicationViewPage-HXFPBXVJ.js.map
