import "./chunk-DN2ZD52M.js";
import "./chunk-J3PH67VS.js";
import "./chunk-CVYJ7ZJF.js";
import "./chunk-BFQ5Q4FG.js";
import {
  TablePage
} from "./chunk-6DOIYWQK.js";
import "./chunk-CG2PRGI3.js";
import "./chunk-UPA2WVNB.js";
import "./chunk-SQ5SVIIR.js";
import "./chunk-2SPTQERF.js";
import "./chunk-KSHJXCLS.js";
import "./chunk-2DGC2NAK.js";
import "./chunk-H6GN2355.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-3NWSPFFH.js";
import "./chunk-TZQOYPLJ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-ENS5JEO5.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-SV4NNFYX.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-7CPINVRB.js";
import "./chunk-6OUYIMM6.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-D7IHD7PN.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/groups/GroupListPage.ts
var GroupListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Groups");
  }
  pageDescription() {
    return msg("Group users together and give them permissions based on the membership.");
  }
  pageIcon() {
    return "pf-icon pf-icon-users";
  }
  async apiEndpoint(page) {
    return new CoreApi(DEFAULT_CONFIG).coreGroupsList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || "",
      includeUsers: false
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Parent"), "parent"),
      new TableColumn(msg("Members")),
      new TableColumn(msg("Superuser privileges?")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Group(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreGroupsUsedByList({
        groupUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreGroupsDestroy({
        groupUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`<a href="#/identity/groups/${item.pk}">${item.name}</a>`,
      x`${item.parentName || msg("-")}`,
      x`${Array.from(item.users || []).length}`,
      x`<ak-label type="info" ?good=${item.isSuperuser}></ak-label>`,
      x`<ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg("Update Group")} </span>
                <ak-group-form slot="form" .instancePk=${item.pk}> </ak-group-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Group")} </span>
                <ak-group-form slot="form"> </ak-group-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], GroupListPage.prototype, "order", 2);
GroupListPage = __decorateClass([
  t("ak-group-list")
], GroupListPage);
export {
  GroupListPage
};
//# sourceMappingURL=GroupListPage-IJSXAVUQ.js.map
