import "./chunk-ZCQ27IAB.js";
import "./chunk-5K3PLUSN.js";
import {
  renderDescriptionList
} from "./chunk-2DDY3SVO.js";
import {
  display_default
} from "./chunk-R2JM5IAT.js";
import "./chunk-NMYJYET6.js";
import "./chunk-RLZHTYA5.js";
import "./chunk-VQFMAUVB.js";
import "./chunk-DN2ZD52M.js";
import "./chunk-J3PH67VS.js";
import {
  RbacApi,
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-CVYJ7ZJF.js";
import "./chunk-ONTZF75C.js";
import "./chunk-DNEL2E46.js";
import "./chunk-EOEQO3CH.js";
import "./chunk-FKNZK3OF.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-BFQ5Q4FG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-CG2PRGI3.js";
import "./chunk-AVL74GZG.js";
import "./chunk-UPA2WVNB.js";
import "./chunk-SQ5SVIIR.js";
import "./chunk-ZIINSVS4.js";
import "./chunk-2SPTQERF.js";
import "./chunk-KSHJXCLS.js";
import "./chunk-2DGC2NAK.js";
import "./chunk-H6GN2355.js";
import "./chunk-IH3CVDIB.js";
import "./chunk-GW7NH4E2.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-3NWSPFFH.js";
import "./chunk-TZQOYPLJ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-ENS5JEO5.js";
import "./chunk-SV4NNFYX.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-7CPINVRB.js";
import "./chunk-6OUYIMM6.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  button_default,
  content_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-D7IHD7PN.js";
import {
  T,
  i,
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/roles/RoleViewPage.ts
var RoleViewPage = class extends AKElement {
  set roleId(id) {
    new RbacApi(DEFAULT_CONFIG).rbacRolesRetrieve({
      uuid: id
    }).then((role) => {
      this._role = role;
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      display_default,
      grid_default,
      content_default,
      card_default,
      description_list_default,
      i`
                .pf-c-description-list__description ak-action-button {
                    margin-right: 6px;
                    margin-bottom: 6px;
                }
                .ak-button-collection {
                    max-width: 12em;
                }
            `
    ];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this._role?.pk)
        return;
      this.roleId = this._role?.pk;
    });
  }
  render() {
    return x`<ak-page-header
                icon="fa fa-lock"
                header=${msg(str`Role ${this._role?.name || ""}`)}
            >
            </ak-page-header>
            ${this.renderBody()}`;
  }
  renderUpdateControl(role) {
    return x` <div class="pf-c-description-list__text">
            <ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg("Update Role")} </span>
                <ak-role-form slot="form" .instancePk=${role.pk}> </ak-role-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Edit")}</button>
            </ak-forms-modal>
        </div>`;
  }
  renderBody() {
    if (!this._role) {
      return T;
    }
    return x` <ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-3-col-on-xl pf-m-3-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Role Info")}</div>
                        <div class="pf-c-card__body">
                            ${renderDescriptionList([
      [msg("Name"), this._role.name],
      [msg("Edit"), this.renderUpdateControl(this._role)]
    ])}
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-9-col-on-xl pf-m-9-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Changelog")}</div>
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.roleId}
                                targetModelApp="authentik_rbac"
                                targetModelName="role"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.RbacRole}
                objectPk=${this._role.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], RoleViewPage.prototype, "roleId", 1);
__decorateClass([
  r()
], RoleViewPage.prototype, "_role", 2);
RoleViewPage = __decorateClass([
  t("ak-role-view")
], RoleViewPage);
export {
  RoleViewPage
};
//# sourceMappingURL=RoleViewPage-PJEFQML5.js.map
