import "./chunk-HIL4UHKM.js";
import "./chunk-SEQFC2V3.js";
import {
  WizardPage
} from "./chunk-KZQQG4Z5.js";
import "./chunk-C2K6T7GB.js";
import {
  TablePage
} from "./chunk-6DOIYWQK.js";
import "./chunk-2KTR6EPW.js";
import "./chunk-TU2PMMWJ.js";
import "./chunk-2MPU2YXM.js";
import "./chunk-SLVUUHE2.js";
import "./chunk-T3WVXGKK.js";
import "./chunk-R6P3V5LC.js";
import "./chunk-2XSPVNET.js";
import "./chunk-JXGF4NCN.js";
import "./chunk-HV5HJC7G.js";
import "./chunk-4TARICXF.js";
import {
  radio_default
} from "./chunk-ZIINSVS4.js";
import "./chunk-2SPTQERF.js";
import "./chunk-KSHJXCLS.js";
import "./chunk-2DGC2NAK.js";
import "./chunk-H6GN2355.js";
import {
  SourcesApi
} from "./chunk-T2IWDPTU.js";
import "./chunk-TJXLCEGC.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-CZCZP242.js";
import "./chunk-IH3CVDIB.js";
import "./chunk-GW7NH4E2.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-3NWSPFFH.js";
import "./chunk-TZQOYPLJ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-ENS5JEO5.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-SV4NNFYX.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-7CPINVRB.js";
import "./chunk-6OUYIMM6.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  n,
  patternfly_base_default,
  t
} from "./chunk-D7IHD7PN.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/sources/SourceWizard.ts
var InitialSourceWizardPage = class extends WizardPage {
  constructor() {
    super(...arguments);
    this.sourceTypes = [];
    this.sidebarLabel = () => msg("Select type");
    this.activeCallback = async () => {
      this.host.isValid = false;
      this.shadowRoot?.querySelectorAll("input[type=radio]").forEach((radio) => {
        if (radio.checked) {
          radio.dispatchEvent(new CustomEvent("change"));
        }
      });
    };
  }
  static get styles() {
    return [patternfly_base_default, form_default, button_default, radio_default];
  }
  render() {
    return x`<form class="pf-c-form pf-m-horizontal">
            ${this.sourceTypes.map((type) => {
      return x`<div class="pf-c-radio">
                    <input
                        class="pf-c-radio__input"
                        type="radio"
                        name="type"
                        id=${`${type.component}-${type.modelName}`}
                        @change=${() => {
        this.host.steps = [
          "initial",
          `type-${type.component}-${type.modelName}`
        ];
        this.host.isValid = true;
      }}
                    />
                    <label class="pf-c-radio__label" for=${`${type.component}-${type.modelName}`}
                        >${type.name}</label
                    >
                    <span class="pf-c-radio__description">${type.description}</span>
                </div>`;
    })}
        </form>`;
  }
};
__decorateClass([
  n({ attribute: false })
], InitialSourceWizardPage.prototype, "sourceTypes", 2);
InitialSourceWizardPage = __decorateClass([
  t("ak-source-wizard-initial")
], InitialSourceWizardPage);
var SourceWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.sourceTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default, radio_default];
  }
  firstUpdated() {
    new SourcesApi(DEFAULT_CONFIG).sourcesAllTypesList().then((types) => {
      this.sourceTypes = types;
    });
  }
  render() {
    return x`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New source")}
                description=${msg("Create a new source.")}
            >
                <ak-source-wizard-initial slot="initial" .sourceTypes=${this.sourceTypes}>
                </ak-source-wizard-initial>
                ${this.sourceTypes.map((type) => {
      return x`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form
                                .args=${{
        modelName: type.modelName
      }}
                                type=${type.component}
                            ></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n({ attribute: false })
], SourceWizard.prototype, "sourceTypes", 2);
SourceWizard = __decorateClass([
  t("ak-source-wizard")
], SourceWizard);

// src/admin/sources/SourceListPage.ts
var SourceListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Federation and Social login");
  }
  pageDescription() {
    return msg(
      "Sources of identities, which can either be synced into authentik's database, or can be used by users to authenticate and enroll themselves."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-middleware";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new SourcesApi(DEFAULT_CONFIG).sourcesAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn("")
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Source(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllUsedByList({
        slug: item.slug
      });
    }}
            .delete=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllDestroy({
        slug: item.slug
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    if (item.component === "") {
      return this.rowInbuilt(item);
    }
    return [
      x`<a href="#/core/sources/${item.slug}">
                <div>${item.name}</div>
                ${item.enabled ? x`` : x`<ak-label color=${"pf-m-orange" /* Orange */} ?compact=${true}>
                          ${msg("Disabled")}</ak-label
                      >`}
            </a>`,
      x`${item.verboseName}`,
      x` <ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                <ak-proxy-form
                    slot="form"
                    .args=${{
        instancePk: item.slug
      }}
                    type=${o(item.component)}
                >
                </ak-proxy-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  rowInbuilt(item) {
    return [
      x`<div>
                <div>${item.name}</div>
                <ak-label color=${"" /* Grey */} ?compact=${true}> ${msg("Built-in")}</ak-label>
            </div>`,
      x`${msg("Built-in")}`,
      x``
    ];
  }
  renderObjectCreate() {
    return x`<ak-source-wizard> </ak-source-wizard> `;
  }
};
__decorateClass([
  n()
], SourceListPage.prototype, "order", 2);
SourceListPage = __decorateClass([
  t("ak-source-list")
], SourceListPage);
export {
  SourceListPage
};
//# sourceMappingURL=SourceListPage-YSTI723C.js.map
