import "./chunk-WI2RLG7Y.js";
import "./chunk-VXZAEZC7.js";
import {
  StagesApi
} from "./chunk-OTXWWNZG.js";
import "./chunk-P6KUVHV4.js";
import "./chunk-LKZJBMFY.js";
import "./chunk-TT4XXIUU.js";
import "./chunk-PBQRLLOY.js";
import "./chunk-VQFMAUVB.js";
import "./chunk-J3PH67VS.js";
import "./chunk-CVYJ7ZJF.js";
import "./chunk-FKNZK3OF.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-KZQQG4Z5.js";
import "./chunk-RUEVKZJR.js";
import "./chunk-PMHZT7EZ.js";
import {
  TablePage
} from "./chunk-6DOIYWQK.js";
import "./chunk-CG2PRGI3.js";
import "./chunk-W6JIMDAN.js";
import "./chunk-COK3ISR5.js";
import "./chunk-AVL74GZG.js";
import "./chunk-UPA2WVNB.js";
import "./chunk-SQ5SVIIR.js";
import "./chunk-2KTR6EPW.js";
import "./chunk-TU2PMMWJ.js";
import "./chunk-T3WVXGKK.js";
import "./chunk-R6P3V5LC.js";
import "./chunk-JXGF4NCN.js";
import "./chunk-HV5HJC7G.js";
import "./chunk-4TARICXF.js";
import "./chunk-ZIINSVS4.js";
import "./chunk-2SPTQERF.js";
import "./chunk-KSHJXCLS.js";
import {
  ModelForm
} from "./chunk-2DGC2NAK.js";
import "./chunk-H6GN2355.js";
import "./chunk-T2IWDPTU.js";
import "./chunk-TJXLCEGC.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-CZCZP242.js";
import "./chunk-IH3CVDIB.js";
import "./chunk-GW7NH4E2.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-3NWSPFFH.js";
import "./chunk-TZQOYPLJ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-KKTAITHX.js";
import {
  showMessage
} from "./chunk-ENS5JEO5.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-SV4NNFYX.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-7CPINVRB.js";
import "./chunk-6OUYIMM6.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-D7IHD7PN.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/stages/authenticator_duo/DuoDeviceImportForm.ts
var DuoDeviceImportForm = class extends ModelForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoRetrieve({
      stageUuid: pk
    });
  }
  getSuccessMessage() {
    return msg("Successfully imported device.");
  }
  async send(data) {
    const importData = data;
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDeviceManualCreate({
      stageUuid: this.instance?.pk || "",
      authenticatorDuoStageManualDeviceImportRequest: importData
    });
  }
  renderForm() {
    return x` ${this.instance?.adminIntegrationKey !== "" ? this.renderFormAutomatic() : x``}
        ${this.renderFormManual()}`;
  }
  renderFormManual() {
    return x`<ak-form-element-horizontal
                label=${msg("User")}
                ?required=${true}
                name="username"
            >
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return x`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.username;
    }}
                >
                </ak-search-select>

                <p class="pf-c-form__helper-text">
                    ${msg("The user in authentik this device will be assigned to.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Duo User ID")}
                ?required=${true}
                name="duoUserId"
            >
                <input type="text" class="pf-c-form-control" required />
                <p class="pf-c-form__helper-text">
                    ${msg("The user ID in Duo, can be found in the URL after clicking on a user.")}
                </p>
            </ak-form-element-horizontal>`;
  }
  renderFormAutomatic() {
    return x`
            <ak-form-element-horizontal label=${msg("Automatic import")}>
                <ak-action-button
                    class="pf-m-primary"
                    .apiRequest=${() => {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDevicesAutomaticCreate({
        stageUuid: this.instance?.pk || ""
      }).then((res) => {
        showMessage({
          level: "info" /* info */,
          message: msg(str`Successfully imported ${res.count} devices.`)
        });
        const modal = this.parentElement;
        modal.open = false;
      });
    }}
                >
                    ${msg("Start automatic import")}
                </ak-action-button>
            </ak-form-element-horizontal>
            <ak-divider>${msg("Or manually import")}</ak-divider>
            <br />
        `;
  }
};
DuoDeviceImportForm = __decorateClass([
  t("ak-stage-authenticator-duo-device-import-form")
], DuoDeviceImportForm);

// src/admin/stages/StageListPage.ts
var StageListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Stages");
  }
  pageDescription() {
    return msg(
      "Stages are single steps of a Flow that a user is guided through. A stage can only be executed from within a flow."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-plugged";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new StagesApi(DEFAULT_CONFIG).stagesAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Flows")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Stage(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllUsedByList({
        stageUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllDestroy({
        stageUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderStageActions(stage) {
    switch (stage.component) {
      case "ak-stage-authenticator-duo-form":
        return x`<ak-forms-modal>
                    <span slot="submit">${msg("Import")}</span>
                    <span slot="header">${msg("Import Duo device")}</span>
                    <ak-stage-authenticator-duo-device-import-form
                        slot="form"
                        .instancePk=${stage.pk}
                    >
                    </ak-stage-authenticator-duo-device-import-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Import devices")}>
                            <i class="fas fa-file-import" aria-hidden="true"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>`;
      default:
        return x``;
    }
  }
  row(item) {
    return [
      x`<div>${item.name}</div>
                <small>${item.verboseName}</small>`,
      x`<ul class="pf-c-list">
                ${item.flowSet?.map((flow) => {
        return x`<li>
                        <a href="#/flow/flows/${flow.slug}">
                            <code>${flow.slug}</code>
                        </a>
                    </li>`;
      })}
            </ul>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${o(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
                ${this.renderStageActions(item)}`
    ];
  }
  renderObjectCreate() {
    return x`<ak-stage-wizard></ak-stage-wizard> `;
  }
};
__decorateClass([
  n()
], StageListPage.prototype, "order", 2);
StageListPage = __decorateClass([
  t("ak-stage-list")
], StageListPage);
export {
  StageListPage
};
//# sourceMappingURL=StageListPage-B73LOFUK.js.map
